/* File: XEventsMQ.h - last edit:
 * MXT		Tue Nov 19 11:23:25 1991
 */

/* Copyright (C) 1992 by Digital Equipment Corporation and Xerox Corporation */

/*	All Rights Reserved
Permission to use, copy, modify, and distribute this software and
its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the names of Digital and Xerox not
be used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  Digital and
Xerox make no representations about the suitability of this software
for any purpose.  It is provided "as is" without express or implied
warranty.
*/

#ifndef XEVENTSMQ_H
#define XEVENTSMQ_H

#ifdef MULTI_THREAD

/*
 * Multiple Event Queue Functions
 */

typedef Bool (*XPredicate) (
#if NeedFunctionPrototypes
    Display*		/* disply */,
    XEvent*		/* event */,
    XPointer		/* arg */
#endif
);

extern XQueue *XCreateEventQueue(
#if NeedFunctionPrototypes
    Display*		/* display */
#endif
);

extern Bool XDestroyEventQueue(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */
#endif
);

extern Bool XCheckIfEventMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    XEvent*		/* event_return */,
    XPredicate		/* predicate */,
    char*		/* arg */
#endif
);

extern Bool XCheckMaskEventMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    long		/* event_mask */,
    XEvent*		/* event_return */
#endif
);

extern Bool XCheckTypedEventMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    int			/* event_type */,
    XEvent*		/* event_return */
#endif
);

extern Bool XCheckTypedWindowEventMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    Window		/* w */,
    int			/* event_type */,
    XEvent*		/* event_return */
#endif
);

extern Bool XCheckWindowEventMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    Window		/* w */,
    long		/* event_mask */,
    XEvent*		/* event_return */
#endif
);

extern int XEventsQueuedMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    int			/* mode */
#endif
);

extern XIfEventMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    XEvent*		/* event_return */,
    XPredicate		/* predicate */,
    char*		/* arg */
#endif
);

extern Bool XIfEventTimeoutMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    XEvent*		/* event_return */,
    XPredicate		/* predicate */,
    char*		/* arg */,
    Timeout		/* timeout */
#endif
);

extern XMaskEventMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    long		/* event_mask */,
    XEvent*		/* event_return */
#endif
);

extern Bool XMaskEventTimeoutMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    long		/* event_mask */,
    XEvent*		/* event_return */,
    Timeout		/* timeout */
#endif
);

extern XNextEventMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    XEvent*		/* event_return */
#endif
);

extern Bool XNextEventTimeoutMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    XEvent*		/* event_return */,
    Timeout		/* timeout */
#endif
);

extern XPeekEventMQ(
#if NeedFunctionPrototypes
    XQueue* 		/* event_queue */,
    XEvent*		/* event_return */
#endif
);

extern Bool XPeekEventTimeoutMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    XEvent*		/* event_return */,
    Timeout		/* timeout */
#endif
);

extern XPeekIfEventMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    XEvent*		/* event_return */,
    XPredicate		/* predicate */,
    char*		/* arg */
#endif
);

extern XPeekIfEventTimeoutMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    XEvent*		/* event_return */,
    XPredicate		/* predicate */,
    char*		/* arg */,
    Timeout		/* timeout */
#endif
);

extern int XPendingMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */
#endif
);

extern XPutBackEventMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    XEvent*		/* event */
#endif
);

extern int XQLengthMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */
#endif
);

extern XSelectInputMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */
    Window		/* w */,
    long		/* event_mask */
#endif
);

extern XRemoveWindowFromQueue(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* ,		/* event_queue */,
    Window		/* w */
#endif
);

extern XSyncMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    Bool		/* discard_events */
#endif
);

extern XWindowEventMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    Window		/* w */,
    long		/* event_mask */,
    XEvent*		/* event_return */
#endif
);

extern Bool XWindowEventTimeoutMQ(
#if NeedFunctionPrototypes
    Display*		/* display */,
    XQueue* 		/* event_queue */,
    Window		/* w */,
    long		/* event_mask */,
    XEvent*		/* event_return */,
    Timeout		/* timeout */
#endif
);

#endif /* MULTI_THREAD */

#endif /* XEVENTSMQ_H */
