/* $XConsortium: XGetAtomNm.c,v 11.16 91/01/06 11:45:52 rws Exp $ */
/* Copyright    Massachusetts Institute of Technology    1986	*/

/*
Permission to use, copy, modify, distribute, and sell this software and its
documentation for any purpose is hereby granted without fee, provided that
the above copyright notice appear in all copies and that both that
copyright notice and this permission notice appear in supporting
documentation, and that the name of M.I.T. not be used in advertising or
publicity pertaining to distribution of the software without specific,
written prior permission.  M.I.T. makes no representations about the
suitability of this software for any purpose.  It is provided "as is"
without express or implied warranty.
*/

#define NEED_REPLIES
#include "Xlibint.h"

char *XGetAtomName(dpy, atom)
register Display *dpy;
Atom atom;
{
#ifdef MULTI_THREAD
    _XQReply *qreply;
    _XQReply *rid;
    xGetAtomNameReply *rep;
#else
    xGetAtomNameReply rep;
#endif
    xResourceReq *req;
    char *storage;

    LockDisplay(dpy);
    GetResReq(GetAtomName, atom, req);

#ifdef MULTI_THREAD
    rid = _XInitReply( dpy, False, SIZEOF(xGetAtomNameReply) );

    UnlockDisplay( dpy );

    qreply = _XReply( dpy, rid );

    if (qreply->status == 0) {
	FreeQReply( qreply );
	SyncHandle();
	return NULL;
    }

    rep = (xGetAtomNameReply *)qreply->reply;

    if (qreply->data_size > sizeof( _XQBlock ) && (rep->nameLength & 3)) {
	storage = qreply->data;
	qreply->data = NULL;
	qreply->data_size = 0;
	storage[rep->nameLength] = '\0';
    }
    else if (storage = (char *) Xmalloc(rep->nameLength+1)) {
	bcopy(qreply->data, storage, rep->nameLength);
	storage[rep->nameLength] = '\0';
    }

    FreeQReply( qreply );
#else
    if (_XReply(dpy, (xReply *)&rep, 0, xFalse) == 0) {
	UnlockDisplay(dpy);
	SyncHandle();
	return(NULL);
    }
    if (storage = (char *) Xmalloc(rep.nameLength+1)) {
	_XReadPad(dpy, storage, (long)rep.nameLength);
	storage[rep.nameLength] = '\0';
    } else {
	_XEatData(dpy, (unsigned long) (rep.nameLength + 3) & ~3);
	storage = (char *) NULL;
    }
    UnlockDisplay(dpy);
#endif	/* MULTI_THREAD */
    SyncHandle();
    return(storage);
}
