/* $XConsortium: XGetSOwner.c,v 11.14 91/01/06 11:46:17 rws Exp $ */
/* Copyright    Massachusetts Institute of Technology    1986	*/

/*
Permission to use, copy, modify, distribute, and sell this software and its
documentation for any purpose is hereby granted without fee, provided that
the above copyright notice appear in all copies and that both that
copyright notice and this permission notice appear in supporting
documentation, and that the name of M.I.T. not be used in advertising or
publicity pertaining to distribution of the software without specific,
written prior permission.  M.I.T. makes no representations about the
suitability of this software for any purpose.  It is provided "as is"
without express or implied warranty.
*/

#define NEED_REPLIES
#include "Xlibint.h"

Window XGetSelectionOwner(dpy, selection)
register Display *dpy;
Atom selection;
{
#ifdef MULTI_THREAD
    _XQReply *rid;
    Window owner;
    _XQReply *qreply;
    xGetSelectionOwnerReply *rep;
#else
    xGetSelectionOwnerReply rep;
#endif
    register xResourceReq *req;

    LockDisplay(dpy);
    GetResReq(GetSelectionOwner, selection, req);

#ifdef MULTI_THREAD
    rid = _XInitReply( dpy, False, SIZEOF(xGetSelectionOwnerReply) );

    UnlockDisplay(dpy);

    qreply = _XReply(dpy, rid);

    rep = (xGetSelectionOwnerReply *)qreply->reply;

    if (qreply->status)
	owner = rep->owner;
    else
	owner = None;

    FreeQReply( qreply );
    SyncHandle();

    return owner;
#else

    if (_XReply(dpy, (xReply *)&rep, 0, xTrue) == 0) rep.owner = None;
    UnlockDisplay(dpy);
    SyncHandle();
    return(rep.owner);
#endif
}
