/* $XConsortium: XGrKeybd.c,v 11.16 91/01/06 11:46:25 rws Exp $ */
/* Copyright    Massachusetts Institute of Technology    1986	*/

/*
Permission to use, copy, modify, distribute, and sell this software and its
documentation for any purpose is hereby granted without fee, provided that
the above copyright notice appear in all copies and that both that
copyright notice and this permission notice appear in supporting
documentation, and that the name of M.I.T. not be used in advertising or
publicity pertaining to distribution of the software without specific,
written prior permission.  M.I.T. makes no representations about the
suitability of this software for any purpose.  It is provided "as is"
without express or implied warranty.
*/

#define NEED_REPLIES
#include "Xlibint.h"
int XGrabKeyboard (dpy, window, ownerEvents, pointerMode, keyboardMode, time)
    register Display *dpy;
    Window window;
    Bool ownerEvents;
    int pointerMode, keyboardMode;
    Time time;
{
#ifdef MULTI_THREAD
	_XQReply *rid;
	_XQReply *qreply;
        xGrabKeyboardReply *rep;
#else
        xGrabKeyboardReply rep;
#endif
	register xGrabKeyboardReq *req;
	register int status;

	LockDisplay(dpy);
        GetReq(GrabKeyboard, req);
	req->grabWindow = window;
	req->ownerEvents = ownerEvents;
	req->pointerMode = pointerMode;
	req->keyboardMode = keyboardMode;
	req->time = time;
#ifdef MULTI_THREAD
	rid = _XInitReply( dpy, False, SIZEOF(xGrabKeyboardReply) );

	UnlockDisplay(dpy);

	qreply = _XReply(dpy, rid);

	rep = (xGrabKeyboardReply *)qreply->reply;

	if (qreply->status)
	    status = rep->status;
	else
	    status = GrabSuccess;

	FreeQReply( qreply );
#else	/* MULTI_THREAD */
       /* if we ever return, suppress the error */
	if (_XReply (dpy, (xReply *) &rep, 0, xTrue) == 0) 
		rep.status = GrabSuccess;
	status = rep.status;
	UnlockDisplay(dpy);

#endif	/* MULTI_THREAD */

	SyncHandle();
	return (status);
}

