/* $XConsortium: XLiProps.c,v 11.20 91/01/06 11:46:49 rws Exp $ */
/* Copyright    Massachusetts Institute of Technology    1986	*/

/*
Permission to use, copy, modify, distribute, and sell this software and its
documentation for any purpose is hereby granted without fee, provided that
the above copyright notice appear in all copies and that both that
copyright notice and this permission notice appear in supporting
documentation, and that the name of M.I.T. not be used in advertising or
publicity pertaining to distribution of the software without specific,
written prior permission.  M.I.T. makes no representations about the
suitability of this software for any purpose.  It is provided "as is"
without express or implied warranty.
*/

#define NEED_REPLIES
#include "Xlibint.h"

Atom *XListProperties(dpy, window, n_props)
register Display *dpy;
Window window;
int *n_props;  /* RETURN */
{
    long nbytes;
    Atom *properties;
    register xResourceReq *req;
#ifdef MULTI_THREAD
    _XQReply *qreply, *rid;
    xListPropertiesReply *rep;
#else
    xListPropertiesReply rep;
#endif

    LockDisplay(dpy);
    GetResReq(ListProperties, window, req);
#ifdef MULTI_THREAD
    rid = _XInitReply( dpy, False, SIZEOF(xListPropertiesReply) );

    UnlockDisplay( dpy );

    qreply = _XReply( dpy, rid );

    if (!qreply->status) {
	FreeQReply( qreply );
	SyncHandle();
	*n_props = 0;
	return ((Atom *) NULL);
    }

    rep = (xListPropertiesReply *)qreply->reply;

    if (rep->nProperties) {
	nbytes = rep->nProperties * sizeof(Atom);

	if (qreply->data_size > sizeof( _XQBlock )) {
	    properties = (Atom *)qreply->data;
	    qreply->data = NULL;
	    qreply->data_size = 0;
	}
	else {
	    properties = (Atom *) Xmalloc ((unsigned) nbytes);
	    nbytes = rep->nProperties << 2;
	    if (! properties) {
		FreeQReply( qreply );
		SyncHandle();
		return (Atom *) NULL;
	    }
	    bcopy(qreply->data, (char *)properties, nbytes);
	}
    }
    else properties = (Atom *) NULL;

    *n_props = rep->nProperties;

    FreeQReply( qreply );
#else	/* MULTI_THREAD */
    if (!_XReply(dpy, (xReply *)&rep, 0, xFalse)) {
	*n_props = 0;
	UnlockDisplay(dpy);
        SyncHandle();
	return ((Atom *) NULL);
    }

    if (rep.nProperties) {
	nbytes = rep.nProperties * sizeof(Atom);
	properties = (Atom *) Xmalloc ((unsigned) nbytes);
	nbytes = rep.nProperties << 2;
	if (! properties) {
	    _XEatData(dpy, (unsigned long) nbytes);
	    UnlockDisplay(dpy);
	    SyncHandle();
	    return (Atom *) NULL;
	}
	_XRead32 (dpy, (char *) properties, nbytes);
    }
    else properties = (Atom *) NULL;

    *n_props = rep.nProperties;
    UnlockDisplay(dpy);

#endif	/* MULTI_THREAD */

    SyncHandle();
    return (properties);
}
