/* $XConsortium: XQuStipShp.c,v 11.11 91/01/06 11:47:35 rws Exp $ */
/* Copyright    Massachusetts Institute of Technology    1986	*/

/*
Permission to use, copy, modify, distribute, and sell this software and its
documentation for any purpose is hereby granted without fee, provided that
the above copyright notice appear in all copies and that both that
copyright notice and this permission notice appear in supporting
documentation, and that the name of M.I.T. not be used in advertising or
publicity pertaining to distribution of the software without specific,
written prior permission.  M.I.T. makes no representations about the
suitability of this software for any purpose.  It is provided "as is"
without express or implied warranty.
*/

#define NEED_REPLIES
#include "Xlibint.h"

Status XQueryBestStipple(dpy, drawable, width, height, ret_width, ret_height)
     register Display *dpy;
     Drawable drawable;
     unsigned int width, height;
     unsigned int *ret_width, *ret_height;
{       
#ifdef MULTI_THREAD
    _XQReply *qreply;
    _XQReply *rid;
    xQueryBestSizeReply *rep;
#else
    xQueryBestSizeReply rep;
#endif
    register xQueryBestSizeReq *req;

    LockDisplay(dpy);
    GetReq(QueryBestSize, req);
    req->class = StippleShape;
    req->drawable = drawable;
    req->width = width;
    req->height = height;

#ifdef MULTI_THREAD

    rid = _XInitReply( dpy, False, SIZEOF(xQueryBestSizeReply) );

    UnlockDisplay( dpy );

    qreply = _XReply( dpy, rid );

    if (!qreply->status) {
	FreeQReply( qreply );
	SyncHandle();
	return 0;
    }

    rep = (xQueryBestSizeReply *)qreply->reply;

    *ret_width = rep->width;
    *ret_height = rep->height;

    FreeQReply( qreply );

#else

    if (_XReply (dpy, (xReply *)&rep, 0, xTrue) == 0) {
	UnlockDisplay(dpy);
	SyncHandle();
	return 0;
	}
    *ret_width = rep.width;
    *ret_height = rep.height;
    UnlockDisplay(dpy);

#endif	/* MULTI_THREAD */

    SyncHandle();
    return 1;
}

