/*
 * Xau - X Authorization Database Library
 *
 * $XConsortium: AuDispose.c,v 1.3 91/01/08 15:08:21 gildea Exp $
 *
 * Copyright 1988 Massachusetts Institute of Technology
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of M.I.T. not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  M.I.T. makes no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * Author:  Keith Packard, MIT X Consortium
 */

#include <X11/Xauth.h>

#ifdef PCR
#include "PCR.h"
#endif


void
XauDisposeAuth (auth)
Xauth	*auth;
{
    if (auth) {
	if (auth->address) (void) Xfree (auth->address);
	if (auth->number) (void) Xfree (auth->number);
	if (auth->name) (void) Xfree (auth->name);
	if (auth->data) (void) Xfree (auth->data);
	Xfree ((char *) auth);
    }
    return;
}
