/*
 * TestTK.h - header file for test program toolkit
 */

#ifndef _TESTTK_H_
#define _TESTTK_H_	1

#include	"XlibTK.h"

/*
 * default parameters
 */

#define	FONTNAME	"-*-*-medium-r-normal--*-120-*-*-*-*-iso8859-1"
#define COLSPACE	5
#define ROWSPACE	5
#define	BORDER		5
#define NUMCOLS		3
#define WINNAME		"Xlib Test Program - Top Level"
#define ICONNAME	"X Tests"
#define DELATOMNAME	"XLT_DELETE_ATOM"

/*
 * state of tests
 */

#define	TEST_STOPPED	0
#define	TEST_RUNNING	1

/*
 * defaults structure
 * provides some default values for all tests running
 */

typedef struct _defaults
{
    Display	*dpy;		/* display */
    Window	top_win;	/* top level window */
    GC		normGC;		/* generic GC */
    GC		revGC;		/* generic reversed (fg<->bg) GC */
    XFontStruct	*font_info;	/* font from default GC */
    unsigned long	black_pix;
    unsigned long	white_pix;
    Atom	del_atom;	/* property to signal shutdown */
    Boolean	shm_flag;	/* is shared memory in use? */
    int		state;		/* state of the test */
}	*Defaults;

/*
 * test data structure
 * data for each test that is started
 */

typedef struct _test_data
{
    Defaults	defaults;	/* defaults for the program */
    Window	window;		/* window for this test */
    void	*data;		/* test specified data */
}	*TestData;

/*
 * test info structure
 * this data is used to start a test
 */

typedef struct _test_info
{
    char	*name;		/* name of test */
    void	*(*proc)();	/* test procedure to call */
    void	*data;		/* test specified data */
    Defaults	defaults;	/* test program defaults */
    Geometry	geometry;	/* recommended size of window */
}	TestInfoStruct, *TestInfo;

#endif	/* ! _TESTTK_H_ */
